#define _GNU_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>

#define FLAG_SZ 32

static char *
get_flag_path(void)
{
	static char ret[4096];
	uid_t uid = getuid();
	struct passwd *pwd = getpwuid(uid);
	if (!pwd) {
		perror("getpwuid");
		exit(-1);
	}
	if (geteuid() != uid) {
		printf("euid != uid\n");
		exit(-1);
	}

	snprintf(ret, sizeof ret, "%s/%s", pwd->pw_dir, "lvl06/flag6");
	return &ret[0];
}

int
main(int argc, char *argv[])
{
	int fd = open(get_flag_path(), O_RDONLY|O_CLOEXEC);
	char flag[FLAG_SZ];
	ssize_t b;
	static void *my_buffer;
	size_t len;

	if (argc != 2) {
		printf("Usage: %s flag\n", argv[0]);
		exit(-1);
	}

	if (fd < 0) {
		perror("open");
		exit(-1);
	}

	b = read(fd, flag, FLAG_SZ);
	if (b != FLAG_SZ) {
		perror("read");
		exit(-1);
	}

	if (strlen(argv[1]) == FLAG_SZ &&
			!memcmp(flag, argv[1], FLAG_SZ)) {
		printf("You got the flag! ... and a shell\n");
		execle("/bin/bash", "/bin/bash", "-p", NULL, NULL);
		perror("execle");
		exit(-1);
	} else {
		printf("Wrong! As a consolation you can run some unpriviledged"
			" code!\n");
		if (setresgid(getgid(), getgid(), getgid())) {
			perror("setresgid");
			exit(-1);
		}
		my_buffer = mmap(NULL, 0x1000,
				PROT_READ|PROT_WRITE|PROT_EXEC,
				MAP_ANONYMOUS|MAP_PRIVATE, -1, 0);
		if (MAP_FAILED == my_buffer) {
			perror("mmap");
			exit(-1);
		}
		fgets(my_buffer, 0x1000, stdin);
		len = strlen(my_buffer);
		/* Shellcode, you know ... no zeroes */
		memset(my_buffer+len, 0,
				0x1000-len);
		printf("jumping at %p[%d]\n", my_buffer, len);
		((void(*)(void))(my_buffer))();
		exit(-1);
	}
	exit(0);
	return 0;
}
