#define _GNU_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>

#define FLAG_SZ 32

static char *
get_flag_path(void)
{
	static char ret[4096];
	uid_t uid = getuid();
	struct passwd *pwd = getpwuid(uid);
	if (!pwd) {
		perror("getpwuid");
		exit(-1);
	}
	if (geteuid() != uid) {
		printf("euid != uid\n");
		exit(-1);
	}

	snprintf(ret, sizeof ret, "%s/%s", pwd->pw_dir, "lvl07/flag7");
	return &ret[0];
}

static void
get_flag(char *flag_ptr)
{
	ssize_t b;
	int fd = open(get_flag_path(), O_RDONLY|O_CLOEXEC);

	if (fd < 0) {
		perror("open");
		exit(-1);
	}

	b = read(fd, flag_ptr, FLAG_SZ);
	if (b != FLAG_SZ) {
		perror("read");
		exit(-1);
	}
	close(fd);
}

static void *my_buffer;
static size_t len;

int
main(int argc, char *argv[])
{
	char flag[FLAG_SZ];

	if (argc != 2) {
		printf("Usage %s flag\n", argv[0]);
		exit(-1);
	}

	get_flag(flag);

	if (strlen(argv[1]) == FLAG_SZ &&
			!memcmp(flag, argv[1], FLAG_SZ)) {
		printf("You got the flag! ... and a shell\n");
		execle("/bin/bash", "/bin/bash", "-p", NULL, NULL);
		perror("execle");
		exit(-1);
	} else {
		char msg[512];
		printf("Wrong! As a consolation you:\n"
				"* get the first char of the flag AND\n"
				"* can run some unpriviledged code\n");

		if (setresgid(getgid(), getgid(), getgid())) {
			perror("setresgid");
			exit(-1);
		}

		snprintf(msg, sizeof msg, "flag 0=%c\n", flag[0]);
		puts(msg);

		my_buffer = mmap(NULL, 0x1000,
				PROT_READ|PROT_WRITE|PROT_EXEC,
				MAP_ANONYMOUS|MAP_PRIVATE, -1, 0);
		if (MAP_FAILED == my_buffer) {
			perror("mmap");
			exit(-1);
		}
		fgets(my_buffer, 0x1000, stdin);
		len = strlen(my_buffer);
		/* Shellcode, you know ... no zeroes */
		memset(my_buffer+len, 0,
				0x1000-len);
		if (((unsigned char *)my_buffer)[0] != 0x48 ||
				((unsigned char *)my_buffer)[1] != 0x31 ||
				((unsigned char *)my_buffer)[2] != 0xc0) {
			printf("I don't like your shellcode!\n");
			exit(-1);
		}
		printf("jumping at %p[%ld]\n", my_buffer, len);
		//asm("int $3\n");
		/* this should be safe */
		asm("xorq %rax, %rax\n");
		asm("xorq %rbx, %rbx\n");
		asm("xorq %rcx, %rcx\n");
		asm("xorq %rdx, %rdx\n");
		asm("xorq %rsp, %rsp\n");
		asm("xorq %rbp, %rbp\n");
		asm("xorq %rdi, %rdi\n");
		asm("xorq %rsi, %rsi\n");
		asm("xorq %r8, %r8\n");
		asm("xorq %r9, %r9\n");
		asm("xorq %r10, %r10\n");
		asm("xorq %r11, %r11\n");
		asm("xorq %r12, %r12\n");
		asm("xorq %r13, %r13\n");
		asm("xorq %r14, %r14\n");
		asm("xorq %r15, %r15\n");
		//asm("int $3\n");
		asm("jmp *%[buff]\n" :: [buff] "rax" (my_buffer));
		exit(-1);
	}
	exit(0);
	return 0;
}
